# des.h File Reference

## Detailed Description

Copyright (C) 2006-2009, Paul Bakker <polarssl_maintainer at polarssl.org> All rights reserved.

Joined copyright on original XySSL code with: Christophe Devine

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Definition in file des.h.

Go to the source code of this file.

## Data Structures
struct | des3_context
| Triple-DES context structure. More...
struct | des_context
| DES context structure. More...
## Defines
#define | DES_DECRYPT 0
#define | DES_ENCRYPT 1
## Functions
void | des3_crypt_cbc (des3_context *ctx, int mode, int length, unsigned char iv[8], unsigned char *input, unsigned char *output)
| 3DES-CBC buffer encryption/decryption
void | des3_crypt_ecb (des3_context *ctx, unsigned char input[8], unsigned char output[8])
| 3DES-ECB block encryption/decryption
void | des3_set2key_dec (des3_context *ctx, unsigned char key[16])
| Triple-DES key schedule (112-bit, decryption).
void | des3_set2key_enc (des3_context *ctx, unsigned char key[16])
| Triple-DES key schedule (112-bit, encryption).
void | des3_set3key_dec (des3_context *ctx, unsigned char key[24])
| Triple-DES key schedule (168-bit, decryption).
void | des3_set3key_enc (des3_context *ctx, unsigned char key[24])
| Triple-DES key schedule (168-bit, encryption).
void | des_crypt_cbc (des_context *ctx, int mode, int length, unsigned char iv[8], unsigned char *input, unsigned char *output)
| DES-CBC buffer encryption/decryption.
void | des_crypt_ecb (des_context *ctx, unsigned char input[8], unsigned char output[8])
| DES-ECB block encryption/decryption.
int | des_self_test (int verbose)
void | des_setkey_dec (des_context *ctx, unsigned char key[8])
| DES key schedule (56-bit, decryption).
void | des_setkey_enc (des_context *ctx, unsigned char key[8])
| DES key schedule (56-bit, encryption).

## Define Documentation

#define DES_DECRYPT 0

Definition at line 27 of file des.h.

#define DES_ENCRYPT 1

Definition at line 26 of file des.h.

## Function Documentation

void des3_crypt_cbc | ( | des3_context * | ctx,
|  | int | mode,
|  | int | length,
|  | unsigned char | iv[8],
|  | unsigned char * | input,
|  | unsigned char * | output |
| ) |  |  |

3DES-CBC buffer encryption/decryption

Parameters:

  | ctx | 3DES context
  | mode | DES_ENCRYPT or DES_DECRYPT
  | length | length of the input data
  | iv | initialization vector (updated after use)
  | input | buffer holding the input data
  | output | buffer holding the output data

void des3_crypt_ecb | ( | des3_context * | ctx,
|  | unsigned char | input[8],
|  | unsigned char | output[8] |
| ) |  |  |

3DES-ECB block encryption/decryption

Parameters:

  | ctx | 3DES context
  | input | 64-bit input block
  | output | 64-bit output block

void des3_set2key_dec | ( | des3_context * | ctx,
|  | unsigned char | key[16] |
| ) |  |  |

Triple-DES key schedule (112-bit, decryption).

Parameters:

  | ctx | 3DES context to be initialized
  | key | 16-byte secret key

void des3_set2key_enc | ( | des3_context * | ctx,
|  | unsigned char | key[16] |
| ) |  |  |

Triple-DES key schedule (112-bit, encryption).

Parameters:

  | ctx | 3DES context to be initialized
  | key | 16-byte secret key

void des3_set3key_dec | ( | des3_context * | ctx,
|  | unsigned char | key[24] |
| ) |  |  |

Triple-DES key schedule (168-bit, decryption).

Parameters:

  | ctx | 3DES context to be initialized
  | key | 24-byte secret key

void des3_set3key_enc | ( | des3_context * | ctx,
|  | unsigned char | key[24] |
| ) |  |  |

Triple-DES key schedule (168-bit, encryption).

Parameters:

  | ctx | 3DES context to be initialized
  | key | 24-byte secret key

void des_crypt_cbc | ( | des_context * | ctx,
|  | int | mode,
|  | int | length,
|  | unsigned char | iv[8],
|  | unsigned char * | input,
|  | unsigned char * | output |
| ) |  |  |

DES-CBC buffer encryption/decryption.

Parameters:

  | ctx | DES context
  | mode | DES_ENCRYPT or DES_DECRYPT
  | length | length of the input data
  | iv | initialization vector (updated after use)
  | input | buffer holding the input data
  | output | buffer holding the output data

void des_crypt_ecb | ( | des_context * | ctx,
|  | unsigned char | input[8],
|  | unsigned char | output[8] |
| ) |  |  |

DES-ECB block encryption/decryption.

Parameters:

  | ctx | DES context
  | input | 64-bit input block
  | output | 64-bit output block

int des_self_test | ( | int | verbose | ) |

void des_setkey_dec | ( | des_context * | ctx,
|  | unsigned char | key[8] |
| ) |  |  |

DES key schedule (56-bit, decryption).

Parameters:

  | ctx | DES context to be initialized
  | key | 8-byte secret key

void des_setkey_enc | ( | des_context * | ctx,
|  | unsigned char | key[8] |
| ) |  |  |

DES key schedule (56-bit, encryption).

Parameters:

  | ctx | DES context to be initialized
  | key | 8-byte secret key